VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCommonDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'Class Name:    clsCommonDlg
'File Name:     CommonDlg.cls
'Dev Platform:  Windows 98SE
'Min. Platform: Windows 95 w/ IE 4
'Programmer:    Tom Blackburn
'Email:         geekamok@aol.com
'Date:          8/16/2002
'Description:   Class to replace CommonDialog control using Windows API functions. _
                The following dialogs can be created using this class; _
                    1. File Open _
                    2. File Save As _
                    3. Color _
                    4. Font _
                    5. Printer
'Requirements:  No project references outside this class required.
'Programming _
 Notes:         This class is quite large but it is still not comprehensive. _
                Several functions have not been implemented and all that have may _
                not be necessary for a specific application.  Many constants _
                have been included for reference that will be rarely, if ever, _
                used.  An attempt has been made to group each dialog's code _
                together.  Comment out what you don 't need.
        '            ignosecond (g-no-skend) noun _
                     1. The extremely short time between when you press the _
                        delete key and when you realize that you really do need _
                        to keep it.
'Acknowledge:  Structures, constants and API function descriptions are from _
               various versions of the Microsoft Corp. MSDN library.  Some of _
               the code is original.  A large portion of it was gleaned from _
               several sources that swore it was not copyrighted and freely _
               available for use.  Enjoy!

Option Explicit

'********************************************************
'*                                                      *
'*  Section:    Boilerplate Declarations                *
'*  Dialogs:    All                                     *
'*  Comments:   Declarations in this section are common *
'*              to all dialogs and should not be        *
'*              discarded.                              *
'*                                                      *
'********************************************************

'   ---- Boilerplate API Function Declarations -----

'The CommDlgExtendedError function returns a common dialog box error code. This _
 code indicates the most recent error to occur during the execution of one of the _
 common dialog box functions.
Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long
'    Native structure - If the most recent call to a common dialog box function _
                        succeeded, the return value is undefined. _
                        If the common dialog box function returned FALSE because _
                        the user closed or canceled the dialog box, the return _
                        value is zero. Otherwise, the return value is a nonzero _
                        error code.
'    DWORD CommDlgExtendedError(VOID)

'   ----  CommDlgExtendedError() Return Error Code Constants -----

    'Common for all dialog boxes
Const CDERR_DIALOGFAILURE       As Integer = &HFFFF
'Const CDERR_GENERALCODES       As Integer = &H0
'Const CDERR_STRUCTSIZE         As Integer = &H1
'Const CDERR_INITIALIZATION     As Integer = &H2
'Const CDERR_NOTEMPLATE         As Integer = &H3
'Const CDERR_NOHINSTANCE        As Integer = &H4
'Const CDERR_LOADSTRFAILURE     As Integer = &H5
'Const CDERR_FINDRESFAILURE     As Integer = &H6
'Const CDERR_LOADRESFAILURE     As Integer = &H7
'Const CDERR_LOCKRESFAILURE     As Integer = &H8
'Const CDERR_MEMALLOCFAILURE    As Integer = &H9
'Const CDERR_MEMLOCKFAILURE     As Integer = &HA
'Const CDERR_NOHOOK             As Integer = &HB
'Const CDERR_REGISTERMSGFAIL    As Integer = &HC
    'Print Dialog errors
'Const PDERR_PRINTERCODES       As Integer = &H1000
'Const PDERR_SETUPFAILURE       As Integer = &H1001
'Const PDERR_PARSEFAILURE       As Integer = &H1002
'Const PDERR_RETDEFFAILURE      As Integer = &H1003
'Const PDERR_LOADDRVFAILURE     As Integer = &H1004
'Const PDERR_GETDEVMODEFAIL     As Integer = &H1005
'Const PDERR_INITFAILURE        As Integer = &H1006
'Const PDERR_NODEVICES          As Integer = &H1007
'Const PDERR_NODEFAULTPRN       As Integer = &H1008
'Const PDERR_DNDMMISMATCH       As Integer = &H1009
'Const PDERR_CREATEICFAILURE    As Integer = &H100A
'Const PDERR_PRINTERNOTFOUND    As Integer = &H100B
'Const PDERR_DEFAULTDIFFERENT   As Integer = &H100C
    'Font Dialog errors
'Const CFERR_CHOOSEFONTCODES    As Integer = &H2000
'Const CFERR_MAXLESSTHANMIN     As Integer = &H2002
'Const CFERR_NOFONTS            As Integer = &H2001
    'OpenSaveAs files Dialog errors
'Const FNERR_FILENAMECODES      As Integer = &H3000
'Const FNERR_SUBCLASSFAILURE    As Integer = &H3001
Const FNERR_INVALIDFILENAME     As Integer = &H3002
Const FNERR_BUFFERTOOSMALL      As Integer = &H3003
    'Color Dialog errors
'Const CCERR_CHOOSECOLORCODES   As Integer = &H5000

'   ---- Boilerplate Module Variable, Constant & Enum Definitions -----

'Enumeration for type of dialog to create
Public Enum DlgCreate
    dlgOpen = 1
    dlgSaveAs = 2
    dlgColor = 3
    dlgFont = 4
    dlgPrinter = 5
End Enum

Private mstrFileAction  As String   'Internal variable for directing either _
                                     File Open or Save As dialog
Const ERRORTITLE    As String = "Dialog Error"  'Error MsgBox title

'Common internal property variables
Private mCancelError    As Boolean
Private mhwndOwner      As Long
Private mhInstance      As Long
Private mCustData       As Long
Private mHook           As Long
Private mTemplateName   As String


'********************************************************
'*                                                      *
'*  Section:    File Dialogs' Declarations              *
'*  Dialogs:    File Open & Save As                     *
'*  Comments:   Declarations in this section are common *
'*              only to dialogs listed above.           *
'*                                                      *
'********************************************************

'   ---- File Dialogs' Type Structure -----

'The OPENFILENAME structure contains information that the GetOpenFileName _
 and GetSaveFileName functions use to initialize an Open or Save As common _
 dialog box. After the user closes the dialog box, the system returns _
 information about the users selection in this structure.
Private Type OPENFILENAME
    lStructSize       As Long
    hwndOwner         As Long
    hInstance         As Long
    lpstrFilter       As String
    lpstrCustomFilter As String
    nMaxCustFilter    As Long
    nFilterIndex      As Long
    lpstrFile         As String
    nMaxFile          As Long
    lpstrFileTitle    As String
    nMaxFileTitle     As Long
    lpstrInitialDir   As String
    lpstrTitle        As String
    flags             As Long
    nFileOffset       As Integer
    nFileExtension    As Integer
    lpstrDefExt       As String
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
End Type

'   ---- File Dialogs' API Function Declarations -----

'The GetOpenFileName function creates an Open common dialog box that lets the user _
 specify the drive, directory, and the name of a file or set of files to open.
Private Declare Function GetOpenFileName Lib "comdlg32.dll" _
        Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
'    Native structure - If the user specifies a filename and clicks the OK button, _
                        the return value is nonzero. The buffer pointed to by the _
                        lpstrFile member of the OPENFILENAME structure contains _
                        the full path and filename specified by the user. _
                        If the user cancels or closes the Open dialog box or an _
                        error occurs, the return value is zero. To get extended _
                        error information, call the CommDlgExtendedError function.
'    BOOL GetOpenFileName(
'        LPOPENFILENAME lpofn    // pointer to a structure with initialization data
'    );

'The GetSaveFileName function creates a Save common dialog box that lets the user _
 specify the drive, directory, and name of a file to save.
Private Declare Function GetSaveFileName Lib "comdlg32.dll" _
        Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
'    Native structure - (Same as GetOpenFileName above)
'    BOOL GetSaveFileName(
'
'        LPOPENFILENAME lpofn    // pointer to a structure with initialization data
'    );

'   ---- File Dialogs' Module Variable, Constant & Enum Definitions -----

'Enumeration for File Dialogs' type structure "flags"
Public Enum dlgFileFlags
        'All Windows General
    OFN_READONLY = &H1
    OFN_OVERWRITEPROMPT = &H2
    OFN_HIDEREADONLY = &H4
    OFN_NOCHANGEDIR = &H8
    OFN_SHOWHELP = &H10
'    OFN_ENABLEHOOK = &H20
'    OFN_ENABLETEMPLATE = &H40
'    OFN_ENABLETEMPLATEHANDLE = &H80
    OFN_NOVALIDATE = &H100
    OFN_ALLOWMULTISELECT = &H200
    OFN_EXTENSIONDIFFERENT = &H400
    OFN_PATHMUSTEXIST = &H800
    OFN_FILEMUSTEXIST = &H1000
    OFN_CREATEPROMPT = &H2000
    OFN_SHAREAWARE = &H4000
    OFN_NOREADONLYRETURN = &H8000
    OFN_NOTESTFILECREATE = &H10000
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOLONGNAMES = &H40000
        'Windows 95+
    OFN_EXPLORER = &H80000
    OFN_NODEREFERENCELINKS = &H100000
    OFN_LONGNAMES = &H200000
    OFN_ENABLEINCLUDENOTIFY = &H400000
    OFN_ENABLESIZING = &H800000
        'Windows 2000/XP
'    OFN_DONTADDTORECENT = &H2000000
'    OFN_FORCESHOWHIDDEN = &H10000000
End Enum

'Files' Open internal property variables
Private udtOFN          As OPENFILENAME
Private mTitle          As String
Private mCustFilter     As String
Private mDefExt         As String
Private mFilter         As String
Private mFile           As String
Private mInitialDir     As String


'********************************************************
'*                                                      *
'*  Section:    Color Dialog Declarations               *
'*  Dialogs:    Color                                   *
'*  Comments:   Declarations in this section are common *
'*              only to dialogs listed above.           *
'*                                                      *
'********************************************************

'   ---- Color Dialog Type Structure -----

'The CHOOSECOLOR structure contains information the ChooseColor function _
 uses to initialize the Color common dialog box. After the user closes the _
 dialog box, the system returns information about the users selection in _
 this structure.
Private Type CHOOSECOLOR
    lStructSize     As Long
    hwndOwner       As Long
    hInstance       As Long
    RGBResult       As Long
    lpCustColors    As String
    flags           As Long
    lCustData       As Long
    lpfnHook        As Long
    lpTemplateName  As String
End Type

'   ---- Corlor Dialog API Function Declarations -----

'The ChooseColor function creates a Color common dialog box that enables _
 the user to select a color.  << NOTE >> "F" appended to end of function _
 to maintain the structure case.
Private Declare Function ChooseColorF Lib "comdlg32.dll" _
        Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long
'    Native structure - If the user clicks the OK button of the dialog _
                        box, the return value is nonzero. The rgbResult member _
                        of the CHOOSECOLOR structure contains the RGB color _
                        value of the color selected by the user.  If the user _
                        cancels or closes the Color dialog box or an error _
                        occurs, the return value is zero. To get extended _
                        error information, use the CommDlgExtendedError function.
'    BOOL ChooseColor(
'
'        LPCHOOSECOLOR lpcc  // pointer to a structure with initialization data
'    );

'   ---- File Dialogs' Module Variable, Constant & Enum Definitions -----

'Enumeration for Color Dialogs' type structure "flags"
Public Enum dlgClrFlags
        'All Windows General
    CC_RGBINIT = &H1
    CC_FULLOPEN = &H2
    CC_PREVENTFULLOPEN = &H4
    CC_SHOWHELP = &H8
'    CC_ENABLEHOOK = &H10
'    CC_ENABLETEMPLATE = &H20
'    CC_ENABLETEMPLATEHANDLE = &H40
        'Windows 95+
'    CC_SOLIDCOLOR = &H80
'    CC_ANYCOLOR = &H100
End Enum

'Color internal property variables
Private udtCC           As CHOOSECOLOR
Private mCustColors     As String


'********************************************************
'*                                                      *
'*  Section:    Font Dialog Declarations                *
'*  Dialogs:    Font                                    *
'*  Comments:   Declarations in this section are common *
'*              only to dialogs listed above.           *
'*                                                      *
'********************************************************

'   ---- Font Dialog Type Structures -----

'The LOGFONT structure defines the attributes of a font.
Private Type LOGFONT
    lfHeight            As Long
    lfWidth             As Long
    lfEscapement        As Long
    lfOrientation       As Long
    lfWeight            As Long
    lfItalic            As Byte
    lfUnderline         As Byte
    lfStrikeOut         As Byte
    lfCharSet           As Byte
    lfOutPrecision      As Byte
    lfClipPrecision     As Byte
    lfQuality           As Byte
    lfPitchAndFamily    As Byte
    lfFaceName(32)      As Byte 'or Const LF_FACESIZE = 32
End Type

'The CHOOSEFONT structure contains information that the ChooseFont function uses _
 to initialize the Font common dialog box. After the user closes the dialog box, _
 the system returns information about the users selection in this structure.
Private Type CHOOSEFONT
    lStructSize         As Long
    hwndOwner           As Long
    hDC                 As Long
    lpLogFont           As Long
    iPointSize          As Long
    flags               As Long
    rgbColors           As Long
    lCustData           As Long
    lpfnHook            As Long
    lpTemplateName      As String
    hInstance           As Long
    lpszStyle           As String
    nFontType           As Integer
    MISSING_ALIGNMENT   As Integer
    nSizeMin            As Long
    nSizeMax            As Long
End Type

'   ---- Font Dialog API Function Declarations -----

'The ChooseFont function creates a Font common dialog box that enables the user _
 to choose attributes for a logical font. These attributes include a typeface _
 name, style (bold, italic, or regular), point size, effects (underline, _
 strikeout, and text color), and a script (or character set).  << NOTE >> "F" appended to end of function _
 to maintain the structure case.
Private Declare Function ChooseFontF Lib "comdlg32.dll" _
        Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long
'    Native structure - If the user clicks the OK button of the dialog box, the _
                        return value is nonzero. The members of the CHOOSEFONT _
                        structure indicate the users selections.  If the user _
                        cancels or closes the Font dialog box or an error occurs, _
                        the return value is zero. To get extended error _
                        information, call the CommDlgExtendedError function.
'    BOOL ChooseFont(
'
'        LPCHOOSEFONT lpcf   // pointer to structure with initialization data
'    );

'The lstrcpy function copies a string to a buffer.
Private Declare Function lstrcpy Lib "kernel32" _
        Alias "lstrcpyA" (p1 As Any, p2 As Any) As Long
'    Native structure - If the function succeeds, the return value is a pointer _
                        to the buffer.  If the function fails, the return value _
                        is NULL. To get extended error information, call _
                        GetLastError.
'    LPTSTR lstrcpy(
'
'        LPTSTR lpString1,   // address of buffer
'        LPCTSTR lpString2   // address of string to copy
'    );

'   ---- Font Dialogs' Module Variable, Constant & Enum Definitions -----

'Enumeration for Font Dialogs' type structure "flags"
Public Enum dlgFontFlags
        'All Windows General
    CF_SCREENFONTS = &H1
    CF_PRINTERFONTS = &H2
    CF_BOTH = &H3
    CF_SHOWHELP = &H4
'    CF_ENABLEHOOK = &H8
'    CF_ENABLETEMPLATE = &H10
'    CF_ENABLETEMPLATEHANDLE = &H20
    CF_INITTOLOGFONTSTRUCT = &H40
    CF_USESTYLE = &H80
    CF_EFFECTS = &H100
    CF_APPLY = &H200
    CF_ANSIONLY = &H400
    CF_NOVECTORFONTS = &H800
    CF_NOOEMFONTS = &H800
    CF_NOSIMULATIONS = &H1000
    CF_LIMITSIZE = &H2000
    CF_FIXEDPITCHONLY = &H4000
    CF_WYSIWYG = &H8000         'CF_SCREENFONTS & CF_PRINTERFONTS required
    CF_FORCEFONTEXIST = &H10000
    CF_SCALABLEONLY = &H20000
    CF_TTONLY = &H40000
    CF_NOFACESEL = &H80000
    CF_NOSTYLESEL = &H100000
    CF_NOSIZESEL = &H200000
        'Windows 95+
    CF_SCRIPTSONLY = &H400
    CF_SELECTSCRIPT = &H400000
    CF_NOSCRIPTSEL = &H800000
    CF_NOVERTFONTS = &H1000000
End Enum

'Constants returned by udtCF.nFontType
'Const BOLD_FONTTYPE         As Integer = &H100
'Const ITALIC_FONTTYPE       As Integer = &H200
'Const REGULAR_FONTTYPE      As Integer = &H400
'Const SCREEN_FONTTYPE       As Integer = &H2000
'Const SIMULATED_FONTTYPE    As Integer = &H8000
'Const PRINTER_FONTTYPE      As Integer = &H4000

'Constants used by udtLF.lfWeight
'Const FW_DONTCARE   As Integer = 0
'Const FW_THIN       As Integer = 100
'Const FW_EXTRALIGHT As Integer = 200
'Const FW_ULTRALIGHT As Integer = 200
'Const FW_LIGHT      As Integer = 300
'Const FW_NORMAL     As Integer = 400
Const FW_REGULAR    As Integer = 400
'Const FW_MEDIUM     As Integer = 500
'Const FW_SEMIBOLD   As Integer = 600
'Const FW_DEMIBOLD   As Integer = 600
Const FW_BOLD       As Integer = 700
'Const FW_EXTRABOLD  As Integer = 800
'Const FW_ULTRABOLD  As Integer = 800
'Const FW_HEAVY      As Integer = 900
'Const FW_BLACK      As Integer = 900

'Constants used by udtLF.lfCharSet
'Const ANSI_CHARSET          As Byte = 0
'Const DEFAULT_CHARSET       As Byte = 1
'Const SYMBOL_CHARSET        As Byte = 2
'Const SHIFTJIS_CHARSET      As Byte = 128
'Const HANGEUL_CHARSET       As Byte = 129
'Const HANGUL_CHARSET        As Byte = 129
'Const GB2312_CHARSET        As Byte = 134
'Const CHINESEBIG5_CHARSET   As Byte = 136
'Const OEM_CHARSET           As Byte = 255
'    'Win 95+
'Const JOHAB_CHARSET         As Byte = 130
'Const HEBREW_CHARSET        As Byte = 177
'Const ARABIC_CHARSET        As Byte = 178
'Const GREEK_CHARSET         As Byte = 161
'Const TURKISH_CHARSET       As Byte = 162
'Const VIETNAMESE_CHARSET    As Byte = 163
'Const THAI_CHARSET          As Byte = 222
'Const EASTEUROPE_CHARSET    As Byte = 238
'Const RUSSIAN_CHARSET       As Byte = 204
'Const MAC_CHARSET           As Byte = 77
'Const BALTIC_CHARSET        As Byte = 186

'Constants used by udtLF.lfOutPrecision
'Const OUT_DEFAULT_PRECIS        As Byte = 0
'Const OUT_STRING_PRECIS         As Byte = 1
'Const OUT_CHARACTER_PRECIS      As Byte = 2
'Const OUT_STROKE_PRECIS         As Byte = 3
'Const OUT_TT_PRECIS             As Byte = 4
'Const OUT_DEVICE_PRECIS         As Byte = 5
'Const OUT_RASTER_PRECIS         As Byte = 6
'Const OUT_TT_ONLY_PRECIS        As Byte = 7
'Const OUT_OUTLINE_PRECIS        As Byte = 8
'Const OUT_SCREEN_OUTLINE_PRECIS As Byte = 9
'Const OUT_PS_ONLY_PRECIS        As Byte = 10

'Constants used by udtLF.lfClipPrecision
'Const CLIP_DEFAULT_PRECIS   As Byte = 0
'Const CLIP_CHARACTER_PRECIS As Byte = 1
'Const CLIP_STROKE_PRECIS    As Byte = 2
'Const CLIP_MASK             As Byte = &HF
'Const CLIP_LH_ANGLES        As Byte = 16   'defined as (1<<4)
'Const CLIP_TT_ALWAYS        As Byte = 32   'defined as (2<<4)
'Const CLIP_EMBEDDED         As Byte = 128  'defined as (8<<4)

'Constants used by udtLF.lfQuality
'Const DEFAULT_QUALITY   As Byte = 0
'Const DRAFT_QUALITY     As Byte = 1
'Const PROOF_QUALITY     As Byte = 2

'Constants used by udtLF.lfPitchAndFamily _
 The two low-order bits specify the pitch of the font _
 and can be one of the following values:
'Const DEFAULT_PITCH     As Byte = 0
'Const FIXED_PITCH       As Byte = 1
'Const VARIABLE_PITCH    As Byte = 2
'Bits 4 through 7 of the member specify the font _
 family and can be one of the following values: _
 (defined as (0...n<<4)
'Const FF_DONTCARE   As Byte = 0    'Don't care or don't know.
'Const FF_ROMAN      As Byte = 16   'Variable stroke width, serifed.
'                                   'Times Roman, Century Schoolbook, etc.
'Const FF_SWISS      As Byte = 32   'Variable stroke width, sans-serifed.
'                                   'Helvetica, Swiss, etc.
'Const FF_MODERN     As Byte = 48   'Constant stroke width, serifed or sans-serifed.
'                                   'Pica, Elite, Courier, etc.
'Const FF_SCRIPT     As Byte = 64   'Cursive, etc.
'Const FF_DECORATIVE As Byte = 80   'Old English, etc.

'Font internal variables
Private udtCF           As CHOOSEFONT
Private udtLF           As LOGFONT


'********************************************************
'*                                                      *
'*  Section:    Printer Dialog Declarations             *
'*  Dialogs:    Printer                                 *
'*  Comments:   Declarations in this section are common *
'*              only to dialogs listed above.           *
'*                                                      *
'********************************************************

'   ---- Printer Dialog Type Structures -----

'The PRINTDLG structure contains information that the PrintDlg function uses _
 to initialize the Print common dialog box. After the user closes the dialog box, _
 the system returns information about the user-defined print selections in this _
 structure.
Private Type PRINTDLG
    lStructSize         As Long
    hwndOwner           As Long
    hDevMode            As Long
    hDevNames           As Long
    hDC                 As Long
    flags               As Long
    nFromPage           As Integer
    nToPage             As Integer
    nMinPage            As Integer
    nMaxPage            As Integer
    nCopies             As Integer
    hInstance           As Long
    lCustData           As Long
    lpfnPrintHook       As Long
    lpfnSetupHook       As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate      As Long
    hSetupTemplate      As Long
End Type

'The DEVMODE data structure contains information about the device initialization _
 and environment of a printer. (I found several forms of this but this one _
 worked and I haven't experimented)
Private Type DEVMODE
    dmDeviceName        As String * 32  'or Const CCHDEVICENAME = 32
    dmSpecVersion       As Integer
    dmDriverVersion     As Integer
    dmSize              As Integer
    dmDriverExtra       As Integer
    dmFields            As Long
    dmOrientation       As Integer
    dmPaperSize         As Integer
    dmPaperLength       As Integer
    dmPaperWidth        As Integer
    dmScale             As Integer
    dmCopies            As Integer
    dmDefaultSource     As Integer
    dmPrintQuality      As Integer
    dmColor             As Integer
    dmDuplex            As Integer
    dmYResolution       As Integer
    dmTTOption          As Integer
    dmCollate           As Integer
    dmFormName          As String * 32  'or Const CCHFORMNAME = 32
    dmUnusedPadding     As Integer
    dmBitsPerPel        As Integer
    dmPelsWidth         As Long
    dmPelsHeight        As Long
    dmDisplayFlags      As Long
    dmDisplayFrequency  As Long
End Type


'The DEVNAMES structure contains strings that identify the driver, device, and _
 output port names for a printer. The PrintDlg function uses these strings to _
 initialize members in the system-defined Print dialog box. When the user closes _
 the dialog box, information about the selected printer is returned in this _
 structure.
Private Type DEVNAMES
    wDriverOffset   As Integer
    wDeviceOffset   As Integer
    wOutputOffset   As Integer
    wDefault        As Integer
    extra           As String * 100
End Type

'   ---- Printer Dialog API Function Declarations -----

'The PrintDlg function displays a Print dialog box or a Print Setup dialog box. _
 The Print dialog box enables the user to specify the properties of a particular _
 print job.  The Print Setup dialog box should not be used in new applications. _
 It has been superseded by the Page Setup common dialog box created by the _
 PageSetupDlg function.  << NOTE >> "F" appended to end of function to maintain _
 the structure case.
Private Declare Function PrintDlgF Lib "comdlg32.dll" _
        Alias "PrintDlgA" (pPrintdlg As PRINTDLG) As Long
'    Native structure - If the user clicks the OK button, the return value is _
                        nonzero. The members of the PRINTDLG structure pointed _
                        to by the lppd parameter indicate the user's selections. _
                        If the user canceled or closed the Print or Printer Setup _
                        dialog box or an error occurred, the return value is zero. _
                        To get extended error information, use the _
                        CommDlgExtendedError function.
'    BOOL PrintDlg(
'
'        LPPRINTDLG lppd     // address of structure with initialization data
'    );


'The GlobalAlloc function allocates the specified number of bytes from the heap. _
 In the linear Win32 API environment, there is no difference between the local _
 heap and the global heap.
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, _
        ByVal dwBytes As Long) As Long
'    Native structure - If the function succeeds, the return value is the _
                        handle of the newly allocated memory object.  If the _
                        function fails, the return value is NULL. To get extended _
                        error information, call GetLastError.
'    HGLOBAL GlobalAlloc(
'
'        UINT uFlags,    // object allocation attributes
'        DWORD dwBytes   // number of bytes to allocate
'    );


'The GlobalLock function locks a global memory object and returns a pointer to _
 the first byte of the objects memory block. The memory block associated with a _
 locked memory object cannot be moved or discarded. For memory objects allocated _
 with the GMEM_MOVEABLE flag, the function increments the lock count associated _
 with the memory object.
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
'    Native structure - If the function succeeds, the return value is a pointer _
                        to the first byte of the memory block.  If the function _
                        fails, the return value is NULL. To get extended error _
                        information, call GetLastError.
'    LPVOID GlobalLock(
'
'        HGLOBAL hMem    // address of the global memory object
'    );


'The GlobalUnlock function decrements the lock count associated with a memory _
 object that was allocated with the GMEM_MOVEABLE flag. This function has no _
 effect on memory objects allocated with the GMEM_FIXED flag.
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
'    Native structure - If the memory object is still locked after decrementing _
                        the lock count, the return value is a nonzero value. _
                        If the function fails, the return value is zero. To get _
                        extended error information, call GetLastError. If _
                        GetLastError returns NO_ERROR, the memory object is _
                        unlocked.
'    BOOL GlobalUnlock(
'
'        HGLOBAL hMem    // handle to the global memory object
'    );


'The GlobalFree function frees the specified global memory object and _
 invalidates its handle.
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
'    Native structure - If the function succeeds, the return value is NULL.  If _
                        the function fails, the return value is equal to the _
                        handle of the global memory object. To get extended error _
                        information, call GetLastError.
'    HGLOBAL GlobalFree(
'
'        HGLOBAL hMem    // handle to the global memory object
'    );


'The CopyMemory function copies a block of memory from one location to another.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
        (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
'    Native structure - This function has no return value.
'    VOID CopyMemory (
'        PVOID Destination,     // address of copy destination
'        CONST VOID *Source,    // address of block to copy
'        DWORD Length           // size, in bytes, of block to copy
'    );

'   ---- Printer Dialogs' Module Variable, Constant & Enum Definitions -----

'Enumeration for Printer Dialog type structure PRINTDLG.flags
Public Enum dlgPtrFlags
        'All Windows General
    PD_ALLPAGES = &H0
    PD_SELECTION = &H1
    PD_PAGENUMS = &H2
    PD_NOSELECTION = &H4
    PD_NOPAGENUMS = &H8
    PD_COLLATE = &H10
    PD_PRINTTOFILE = &H20
    PD_PRINTSETUP = &H40    ''Superceded by the Page setup dialog
    PD_NOWARNING = &H80
    PD_RETURNDC = &H100
    PD_RETURNIC = &H200
    PD_RETURNDEFAULT = &H400
    PD_SHOWHELP = &H800
'    PD_ENABLEPRINTHOOK = &H1000
'    PD_ENABLESETUPHOOK = &H2000
'    PD_ENABLEPRINTTEMPLATE = &H4000
'    PD_ENABLESETUPTEMPLATE = &H8000
'    PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
'    PD_ENABLESETUPTEMPLATEHANDLE = &H20000
    PD_USEDEVMODECOPIES = &H40000
    PD_USEDEVMODECOPIESANDCOLLATE = &H40000
    PD_DISABLEPRINTTOFILE = &H80000
    PD_HIDEPRINTTOFILE = &H100000
    PD_NONETWORKBUTTON = &H200000
        'Windows 2000/XP
'    PD_CURRENTPAGE = &H400000
'    PD_NOCURRENTPAGE = &H800000
'    PD_EXCLUSIONFLAGS = &H1000000
'    PD_USELARGETEMPLATE = &H10000000
End Enum

    '*Note: Left the following in pretty raw shape

'Constants returned by udtDM.dmFields (as Long)
'/* current version of specification */
'#if (WINVER >= 0x0500) || (_WIN32_WINNT >= 0x0400)
'Const DM_SPECVERSION As Long = &H401
''#elif (WINVER >= 0x0400)
Const DM_SPECVERSION As Long = &H400
''#Else
'Const DM_SPECVERSION As Long = &H320
'#endif /* WINVER */

'/* field selection bits */
Const DM_ORIENTATION          As Long = &H1
Const DM_PAPERSIZE            As Long = &H2
Const DM_PAPERLENGTH          As Long = &H4
Const DM_PAPERWIDTH           As Long = &H8
Const DM_SCALE                As Long = &H10
''#if(WINVER >= 0x0500)
'Const DM_POSITION             As Long = &H20
'Const DM_NUP                  As Long = &H40
''#endif /* WINVER >= 0x0500 */
''#if(WINVER >= 0x0501)
'Const DM_DISPLAYORIENTATION As Long = &H80
''#endif /* WINVER >= 0x0501 */
Const DM_COPIES             As Long = &H100
Const DM_DEFAULTSOURCE      As Long = &H200
Const DM_PRINTQUALITY       As Long = &H400
Const DM_COLOR              As Long = &H800
Const DM_DUPLEX             As Long = &H1000
Const DM_YRESOLUTION        As Long = &H2000
Const DM_TTOPTION           As Long = &H4000
Const DM_COLLATE            As Long = &H8000
Const DM_FORMNAME           As Long = &H10000
Const DM_LOGPIXELS          As Long = &H20000
Const DM_BITSPERPEL         As Long = &H40000
Const DM_PELSWIDTH          As Long = &H80000
Const DM_PELSHEIGHT         As Long = &H100000
Const DM_DISPLAYFLAGS       As Long = &H200000
Const DM_DISPLAYFREQUENCY   As Long = &H400000
'#if(WINVER >= 0x0400)
Const DM_ICMMETHOD          As Long = &H800000
Const DM_ICMINTENT          As Long = &H1000000
Const DM_MEDIATYPE          As Long = &H2000000
Const DM_DITHERTYPE         As Long = &H4000000
Const DM_PANNINGWIDTH       As Long = &H8000000
Const DM_PANNINGHEIGHT      As Long = &H10000000
''#endif /* WINVER >= 0x0400 */
''#if(WINVER >= 0x0501)
'Const DM_DISPLAYFIXEDOUTPUT As Long = &H20000000
''#endif /* WINVER >= 0x0501 */

'Constants returned by udtDM.dmOrientation
Const DMORIENT_PORTRAIT     As Byte = 1
Const DMORIENT_LANDSCAPE    As Byte = 2

'Constants returned by udtDM.dmPaperSize
' paper selections */
'Const DMPAPER_FIRST                 As Byte = 1
'Const DMPAPER_LETTER                As Byte = 1   'Letter 8 1/2 x 11 in
'Const DMPAPER_LETTERSMALL           As Byte = 2   'Letter Small 8 1/2 x 11 in
'Const DMPAPER_TABLOID               As Byte = 3   'Tabloid 11 x 17 in
'Const DMPAPER_LEDGER                As Byte = 4   'Ledger 17 x 11 in
'Const DMPAPER_LEGAL                 As Byte = 5   'Legal 8 1/2 x 14 in
'Const DMPAPER_STATEMENT             As Byte = 6   'Statement 5 1/2 x 8 1/2 in
'Const DMPAPER_EXECUTIVE             As Byte = 7   'Executive 7 1/4 x 10 1/2 in
'Const DMPAPER_A3                    As Byte = 8   'A3 297 x 420 mm
'Const DMPAPER_A4                    As Byte = 9   'A4 210 x 297 mm
'Const DMPAPER_A4SMALL               As Byte = 10  'A4 Small 210 x 297 mm
'Const DMPAPER_A5                    As Byte = 11  'A5 148 x 210 mm
'Const DMPAPER_B4                    As Byte = 12  'B4 (JIS) 250 x 354
'Const DMPAPER_B5                    As Byte = 13  'B5 (JIS) 182 x 257 mm
'Const DMPAPER_FOLIO                 As Byte = 14  'Folio 8 1/2 x 13 in
'Const DMPAPER_QUARTO                As Byte = 15  'Quarto 215 x 275 mm
'Const DMPAPER_10X14                 As Byte = 16  '10x14 in
'Const DMPAPER_11X17                 As Byte = 17  '11x17 in
'Const DMPAPER_NOTE                  As Byte = 18  'Note 8 1/2 x 11 in
'Const DMPAPER_ENV_9                 As Byte = 19  'Envelope #9 3 7/8 x 8 7/8
'Const DMPAPER_ENV_10                As Byte = 20  'Envelope #10 4 1/8 x 9 1/2
'Const DMPAPER_ENV_11                As Byte = 21  'Envelope #11 4 1/2 x 10 3/8
'Const DMPAPER_ENV_12                As Byte = 22  'Envelope #12 4 \276 x 11
'Const DMPAPER_ENV_14                As Byte = 23  'Envelope #14 5 x 11 1/2
'Const DMPAPER_CSHEET                As Byte = 24  'C size sheet
'Const DMPAPER_DSHEET                As Byte = 25  'D size sheet
'Const DMPAPER_ESHEET                As Byte = 26  'E size sheet
'Const DMPAPER_ENV_DL                As Byte = 27  'Envelope DL 110 x 220mm
'Const DMPAPER_ENV_C5                As Byte = 28  'Envelope C5 162 x 229 mm
'Const DMPAPER_ENV_C3                As Byte = 29  'Envelope C3  324 x 458 mm
'Const DMPAPER_ENV_C4                As Byte = 30  'Envelope C4  229 x 324 mm
'Const DMPAPER_ENV_C6                As Byte = 31  'Envelope C6  114 x 162 mm
'Const DMPAPER_ENV_C65               As Byte = 32  'Envelope C65 114 x 229 mm
'Const DMPAPER_ENV_B4                As Byte = 33  'Envelope B4  250 x 353 mm
'Const DMPAPER_ENV_B5                As Byte = 34  'Envelope B5  176 x 250 mm
'Const DMPAPER_ENV_B6                As Byte = 35  'Envelope B6  176 x 125 mm
'Const DMPAPER_ENV_ITALY             As Byte = 36  'Envelope 110 x 230 mm
'Const DMPAPER_ENV_MONARCH           As Byte = 37  'Envelope Monarch 3.875 x 7.5 in
'Const DMPAPER_ENV_PERSONAL          As Byte = 38  '6 3/4 Envelope 3 5/8 x 6 1/2 in
'Const DMPAPER_FANFOLD_US            As Byte = 39  'US Std Fanfold 14 7/8 x 11 in
'Const DMPAPER_FANFOLD_STD_GERMAN    As Byte = 40  'German Std Fanfold 8 1/2 x 12 in
'Const DMPAPER_FANFOLD_LGL_GERMAN    As Byte = 41  'German Legal Fanfold 8 1/2 x 13 in
''#if(WINVER >= 0x0400)
'Const DMPAPER_ISO_B4                As Byte = 42  'B4 (ISO) 250 x 353 mm
'Const DMPAPER_JAPANESE_POSTCARD     As Byte = 43  'Japanese Postcard 100 x 148 mm
'Const DMPAPER_9X11                  As Byte = 44  '9 x 11 in
'Const DMPAPER_10X11                 As Byte = 45  '10 x 11 in
'Const DMPAPER_15X11                 As Byte = 46  '15 x 11 in
'Const DMPAPER_ENV_INVITE            As Byte = 47  'Envelope Invite 220 x 220 mm
'Const DMPAPER_RESERVED_48           As Byte = 48  'RESERVED--DO NOT USE
'Const DMPAPER_RESERVED_49           As Byte = 49  'RESERVED--DO NOT USE
'Const DMPAPER_LETTER_EXTRA          As Byte = 50  'Letter Extra 9 \275 x 12 in
'Const DMPAPER_LEGAL_EXTRA           As Byte = 51  'Legal Extra 9 \275 x 15 in
'Const DMPAPER_TABLOID_EXTRA         As Byte = 52  'Tabloid Extra 11.69 x 18 in
'Const DMPAPER_A4_EXTRA              As Byte = 53  'A4 Extra 9.27 x 12.69 in
'Const DMPAPER_LETTER_TRANSVERSE     As Byte = 54  'Letter Transverse 8 \275 x 11 in
'Const DMPAPER_A4_TRANSVERSE         As Byte = 55  'A4 Transverse 210 x 297 mm
'Const DMPAPER_LETTER_EXTRA_TRANSVERSE     As Byte = 56  'Letter Extra Transverse 9\275 x 12 in
'Const DMPAPER_A_PLUS                As Byte = 57  'SuperA/SuperA/A4 227 x 356 mm
'Const DMPAPER_B_PLUS                As Byte = 58  'SuperB/SuperB/A3 305 x 487 mm
'Const DMPAPER_LETTER_PLUS           As Byte = 59  'Letter Plus 8.5 x 12.69 in
'Const DMPAPER_A4_PLUS               As Byte = 60  'A4 Plus 210 x 330 mm
'Const DMPAPER_A5_TRANSVERSE         As Byte = 61  'A5 Transverse 148 x 210 mm
'Const DMPAPER_B5_TRANSVERSE         As Byte = 62  'B5 (JIS) Transverse 182 x 257 mm
'Const DMPAPER_A3_EXTRA              As Byte = 63  'A3 Extra 322 x 445 mm
'Const DMPAPER_A5_EXTRA              As Byte = 64  'A5 Extra 174 x 235 mm
'Const DMPAPER_B5_EXTRA              As Byte = 65  'B5 (ISO) Extra 201 x 276 mm
'Const DMPAPER_A2                    As Byte = 66  'A2 420 x 594 mm
'Const DMPAPER_A3_TRANSVERSE         As Byte = 67  'A3 Transverse 297 x 420 mm
'Const DMPAPER_A3_EXTRA_TRANSVERSE   As Byte = 68  'A3 Extra Transverse 322 x 445 mm
''#End If ' WINVER >= 0x0400

'#if (WINVER >= 0x0500)
'Const DMPAPER_LAST          As Byte = DMPAPER_PENV_10_ROTATED
'#elif (WINVER >= 0x0400)
'Const DMPAPER_LAST          As Byte = DMPAPER_A3_EXTRA_TRANSVERSE
'#Else
'Const DMPAPER_LAST          As Byte = DMPAPER_FANFOLD_LGL_GERMAN
'#End If

'Printer internal variables
Private udtPD   As PRINTDLG
Private udtDM   As DEVMODE
Private udtDN   As DEVNAMES


'********************************************************
'*                                                      *
'*  Section:    Boilerplate Properties & Methods        *
'*  Dialogs:    All                                     *
'*  Comments:   Procedures in this section are common   *
'*              to all dialogs and should not be        *
'*              discarded.                              *
'*                                                      *
'********************************************************

'   ---- Boilerplate Public Properties & Methods -----

Public Property Let CancelError(ByVal blnCancelError As Boolean)
    'Assign the property CancelError variable
    'CancelError equal "TRUE" allows a dialog to cancel without error _
     or nag prompt and is the default. _
     - Property Get not defined -

    mCancelError = blnCancelError

End Property

Public Property Let hwndOwner(ByVal lngHandle As Long)
    'Assign the Window handle of dialog owner _
     All dialogs should have this set but is generally not required. _
     - Property Get not defined  -

    mhwndOwner = lngHandle

End Property

Public Property Let hInstance(ByVal lngInstance As Long)
    'Assign the handle to memory object containing dialog template. _
     Used with the Hook and TemplateName property. _
     - Property Get not defined  -

    mhInstance = lngInstance

End Property

Public Property Let CustData(ByVal lngCustData As Long)
    'Assign the application-defined data that the system passes to the _
     hook procedure identified by the Hook property. _
     - Property Get not defined -

    mCustData = lngCustData

End Property

Public Property Let Hook(ByVal lngHook As Long)
    'Assign the handle to function containing hook procedure. _
     Used with the x_ENABLEHOOK flag. _
     - Property Get not defined -

    mHook = lngHook

End Property

Public Property Let TemplateName(ByVal strTemplateName As String)
    'Assign the name of a dialog template resource in the module identified _
     by the hInstance property. _
     - Property Get not defined -

    mTemplateName = strTemplateName & Chr(0)

End Property

Public Sub DlgInitialize(ByVal enmDialog As DlgCreate)
    'This method must be the first thing called by the application after _
     instantiating this class object.  The appropriate dialog parameters will _
     be initialized here avoiding the necessity of doing them all in the _
     Class_Initialize() procedure.

    Const strNull   As String = vbNullString

    'Select the type of dialog to be created
    Select Case enmDialog
        Case dlgOpen, dlgSaveAs  'Open & Save As dialog
            With udtOFN
                .lStructSize = Len(udtOFN)
                .lpstrFilter = strNull
                .nMaxCustFilter = 40
                .lpstrCustomFilter = Space(.nMaxCustFilter)
                .nFilterIndex = 1
                .lpstrFile = Space(255)
                .nMaxFile = 256
                .lpstrFileTitle = Space(255)
                .nMaxFileTitle = 256
                .lpstrInitialDir = strNull
                .lpstrTitle = strNull
                .flags = 0
                .lpstrDefExt = strNull
            End With
            'Select action for actual call
            Select Case enmDialog
                Case dlgOpen
                    mstrFileAction = "open"
                Case dlgSaveAs
                    mstrFileAction = "save"
            End Select
        Case dlgColor       'Color dialog
            With udtCC
                .lStructSize = Len(udtCC)
                .RGBResult = 0
                .lpCustColors = String(64, Chr(255))
                .flags = 0
            End With
        Case dlgFont        'Font dialog
            With udtCF
                .lStructSize = Len(udtCF)
                .hDC = Printer.hDC
                .flags = 0
                .rgbColors = 0
                .MISSING_ALIGNMENT = 0
                .nSizeMin = 0
                .nSizeMax = 0
            End With
        Case dlgPrinter       'Printer dialog
            With udtPD
                .lStructSize = Len(udtPD)
                .hDC = 0
                .flags = 0
                .nFromPage = 1
                .nToPage = 1
                .nMinPage = 1
                .nMaxPage = 1
                .lpfnPrintHook = 0
                .lpfnSetupHook = 0
                .lpPrintTemplateName = strNull
                .lpSetupTemplateName = strNull
                .hPrintTemplate = 0
                .hSetupTemplate = 0
            End With
            
            udtDM.dmSize = Len(udtDM)
    End Select

End Sub

'   ---- Boilerplate Private Procedures -----

Private Sub Class_Initialize()
    'Initialize common properties for dialog boxes.  This allows use of defaults _
     without calling procedure intervention.

    'Common dialog properties
    mCancelError = True
    mhInstance = 0
    mCustData = 0
    mHook = 0
    mTemplateName = vbNullString

End Sub

Private Function ChkCancel(ByVal intError As Integer) As Boolean
    'Dialog error checking

    Dim intRSVP As Integer  'MsgBox return value

    ChkCancel = False       'Initialize function return

    If intError = 0 Then
        'Check mCancelError
        If Not mCancelError Then
            'Ask if user wishes to return
            intRSVP = MsgBox("A selection was not made." & vbCrLf & vbCrLf & _
                             "Return to dialog?", vbYesNo + vbDefaultButton2, _
                             ERRORTITLE)
            If intRSVP = vbYes Then ChkCancel = True
        End If
    Else
        'Show unrecoverable dialog error. _
         These are either Windows' or programming errors.
        If intError = CInt(CDERR_DIALOGFAILURE) Then    'Just plain broke
            MsgBox "The dialog could not be created!", , ERRORTITLE
    
        Else    'All others that are programming errors
            MsgBox "Dialog returned error" & vbCrLf & "number = 0x" & _
                    Hex(intError), vbOKOnly, ERRORTITLE
        End If
    End If

End Function


'********************************************************
'*                                                      *
'*  Section:    File Dialogs' Properties & Methods      *
'*  Dialogs:    File Open & Save As                     *
'*  Comments:   Procedures in this section are common   *
'*              only to dialogs listed above and are    *
'*              all public.                             *
'*                                                      *
'********************************************************

Public Property Let Filter(ByVal strFilter As String)
    'Assign the initial file filter value to the dialog _
     - Property Get not defined -

    'Format string
    mFilter = Replace(strFilter, "|", Chr(0)) & String(2, 0)
    'Set it
    udtOFN.lpstrFilter = mFilter

End Property

Public Property Get CustomFilter() As String
    'Retrieve the custom file filter value from the dialog. _
     Programmer must send this property back on next use to be valid.

    CustomFilter = Replace(udtOFN.lpstrCustomFilter, Chr(0), "|", 1, 1)
    CustomFilter = Trim(Replace(CustomFilter, Chr(0), " "))

End Property

Public Property Let CustomFilter(strCustFilter As String)
    'Retrieve the custom file filter value from the dialog.

    Dim lngLen  As Long 'Variable length for padding static buffer

    'Determine pad length
    lngLen = udtOFN.nMaxCustFilter - Len(strCustFilter) - 1

    'Format inport string
    strCustFilter = Replace(strCustFilter, "|", Chr(0)) & Chr(0) & Space(lngLen)

    mCustFilter = strCustFilter             'Get it
    udtOFN.lpstrCustomFilter = mCustFilter  'Set it
    
End Property

Public Property Let MaxCustFilter(ByVal lngMaxCustFilter As Long)
    'Assign the static buffer size of the custom file filter. _
     This must be set BEFORE setting the CustomFilter property unless default _
     is big enough. _
     - Property Get not defined -

    udtOFN.nMaxCustFilter = lngMaxCustFilter
    
    'Reset the static buffer for MaxCustFilter
    udtOFN.lpstrCustomFilter = Space(udtOFN.nMaxCustFilter)

End Property

Public Property Let FilterIndex(ByVal lngFilterIndex As Long)
    'Assign the initial file filter index value to the dialog

    udtOFN.nFilterIndex = lngFilterIndex

End Property

Public Property Get FilterIndex() As Long
    'Retrieve the file filter index value from the dialog

    FilterIndex = udtOFN.nFilterIndex

End Property

Public Property Let File(ByVal strFile As String)
    'Assign the initial file name for the dialog

    mFile = strFile             'Get it
    udtOFN.lpstrFile = mFile    'Set it

End Property

Public Property Get File() As String
    'Retrieve the return file name from the dialog

    File = Trim(Replace(udtOFN.lpstrFile, Chr(0), " "))

End Property

Public Property Let MaxFile(ByVal lngMaxFile As Long)
    'Assign the buffer size of the file name _
     - Property Get not defined -

    udtOFN.nMaxFile = lngMaxFile

End Property

Public Property Get FileTitle() As String
    'Retrieve the return file title from the dialog _
     - No Let Property defined -

    FileTitle = Trim(Replace(udtOFN.lpstrFileTitle, Chr(0), " "))

End Property

Public Property Let MaxFileTitle(ByVal lngMaxFileTitle As Long)
    'Assign the buffer size of the file title _
     - Property Get not defined -

    udtOFN.nMaxFileTitle = lngMaxFileTitle

End Property

Public Property Let InitialDir(ByVal strInitialDir As String)
    'Assign the initial directory value to the dialog _
     - Property Get not defined -

    mInitialDir = strInitialDir             'Set it
    udtOFN.lpstrInitialDir = mInitialDir    'Define it

End Property

Public Property Let DlgTitle(ByVal strTitle As String)
    'Assign the Title for the dialog _
     - Property Get not defined -

    mTitle = strTitle           'Set it
    udtOFN.lpstrTitle = mTitle  'Define it

End Property

Public Property Let FileFlags(ByVal dlgFlags As dlgFileFlags)
    'Assign the flags for dialog initialization _
     - Property Get not defined -

    udtOFN.flags = dlgFlags

End Property

Public Property Get FileOffset() As Integer
    'Retrieve the file offset from the dialog _
     - No Let Property defined -

    FileOffset = udtOFN.nFileOffset

End Property

Public Property Get FileExtension() As Integer
    'Retrieve the file extension offset from the dialog _
     - No Let Property defined -

    FileExtension = udtOFN.nFileExtension

End Property

Public Property Let DefExt(ByVal strExt As String)
    'Assign the initial default extension for the dialog. _
     - Property Get not defined -

    mDefExt = strExt                'Get it
    udtOFN.lpstrDefExt = mDefExt    'Define it

End Property

Public Function ShowOpenSaveAs() As Boolean
    'Show the file open dialog, do error check & return success status

    Dim intRSVP     As Integer  'MsgBox return value
    Dim intError    As Integer  'Dialog error number
    Dim arrSize()   As Byte     'Array to collect required buffer size

    'Final setup of control structure
    With udtOFN
        .hwndOwner = mhwndOwner
        .hInstance = mhInstance
        .lCustData = mCustData
        .lpfnHook = mHook
        .lpTemplateName = mTemplateName
    End With

ReDux:  'Return here for recoverable errors

    'Show the dialog and set the function return value if successful
    Select Case mstrFileAction
        Case "open"
            ShowOpenSaveAs = GetOpenFileName(udtOFN)
        Case "save"
            ShowOpenSaveAs = GetSaveFileName(udtOFN)
    End Select

    If ShowOpenSaveAs Then Exit Function    'Leave if everything is OK
    intError = CommDlgExtendedError()       'Get the error number if not

    'Determine action from error number _
     Check for invalid file name entered
    If intError = CInt(FNERR_INVALIDFILENAME) Then
        intRSVP = MsgBox("The file name entered is invalid!" & vbCrLf & vbCrLf & _
                         "Clear and return to File Dialog?", vbYesNo, ERRORTITLE)
        'Clear file name and try again
        If intRSVP = vbYes Then
            udtOFN.lpstrFile = Space(udtOFN.nMaxFile - 1)
            GoTo ReDux  'Try agin
        End If
    
    'Check for buffer overrun
    ElseIf intError = CInt(FNERR_BUFFERTOOSMALL) Then
        intRSVP = MsgBox("The file name and path was to" & vbCrLf & _
                         "long for the available buffer!" & vbCrLf & vbCrLf & _
                         "Repair and return to File Dialog?", vbYesNo, ERRORTITLE)
        'Fix buffer and try again
        If intRSVP = vbYes Then
            'Put first two bytes of lpstrFile into array
            arrSize() = StrConv(Left(udtOFN.lpstrFile, 2), vbFromUnicode)
            'Resize buffer with feedback
            udtOFN.nMaxFile = CLng(arrSize(0) + arrSize(1)) + 1
            'Clear old file string for new try
            udtOFN.lpstrFile = Space(udtOFN.nMaxFile - 1)
            GoTo ReDux  'Try agin
        End If
    
    Else    'Check for exit of dialog without selection or _
             others that are programming errors
        If ChkCancel(intError) Then GoTo ReDux
    End If

End Function


'********************************************************
'*                                                      *
'*  Section:    Color Dialog Properties & Methods       *
'*  Dialogs:    Color                                   *
'*  Comments:   Procedures in this section are common   *
'*              only to dialogs listed above and are    *
'*              all public.                             *
'*                                                      *
'********************************************************

Public Property Get RGBResult() As Long
    'Retrieve the RGB color property value

    RGBResult = udtCC.RGBResult

End Property

Public Property Let RGBResult(ByVal lngRGBResult As Long)
    'Assign the RGB color property value

    udtCC.RGBResult = lngRGBResult

End Property

Public Property Get CustomColors() As String
    'Retrieve the custom colors property value

    CustomColors = udtCC.lpCustColors

End Property

Public Property Let CustomColors(ByVal strCustClr As String)
    'Assign the custom colors property value

    mCustColors = strCustClr
    udtCC.lpCustColors = mCustColors

End Property

Public Property Let ColorFlags(ByVal dlgFlags As dlgClrFlags)
    'Assign the flags for dialog initialization _
     - Property Get not defined -

    udtCC.flags = dlgFlags

End Property

Public Function ShowColor() As Boolean
    'Show the color dialog, do error check & return success status

    Dim intError    As Integer  'Dialog error number

    'Final setup of control structure
    With udtCC
        .hwndOwner = mhwndOwner
        .hInstance = mhInstance
        .lCustData = mCustData
        .lpfnHook = mHook
        .lpTemplateName = mTemplateName
    End With

ReDux:  'Return here for recoverable errors

    'Show the dialog and set the function return value if successful
    ShowColor = ChooseColorF(udtCC)

    If ShowColor Then Exit Function     'Leave if everything is OK
    intError = CommDlgExtendedError()   'Get the error number if not

    'Check for exit of dialog without selection or _
     others that are programming errors
    If ChkCancel(intError) Then GoTo ReDux

End Function


'********************************************************
'*                                                      *
'*  Section:    Font Dialog Properties & Methods        *
'*  Dialogs:    Font                                    *
'*  Comments:   Procedures in this section are common   *
'*              only to dialogs listed above and are    *
'*              all public.                             *
'*                                                      *
'********************************************************

Public Property Let FontBold(ByVal blnBold As Boolean)
    'Assign the font bold property value

    If blnBold Then
        udtLF.lfWeight = FW_BOLD
    Else
        udtLF.lfWeight = FW_REGULAR
    End If

End Property

Public Property Get FontBold() As Boolean
    'Retrieve the font bold property value

    FontBold = False
    If udtLF.lfWeight = FW_BOLD Then FontBold = True

End Property

Public Property Let FontColor(lngFontColor As Long)
    'Assign the property FontColor variable. _
     Used only if the CF_EFFECTS flag is set.

    udtCF.rgbColors = lngFontColor

End Property

Public Property Get FontColor() As Long
    'Retrieve the current FontColor variable

    FontColor = udtCF.rgbColors

End Property

Public Property Let FontFlags(ByVal dlgFlags As dlgFontFlags)
    'Assign the flags for dialog initialization _
     - Property Get not defined -

    udtCF.flags = dlgFlags

End Property

Public Property Let FontItalic(ByVal blnItalic As Boolean)
    'Assign the font italic property value

    udtLF.lfItalic = blnItalic

End Property

Public Property Get FontItalic() As Boolean
    'Retrieve the font italic property value

    FontItalic = udtLF.lfItalic

End Property

Public Property Let FontName(ByVal strName As String)
    'Assign the font name property value

    Dim bytWork()   As Byte     'Workin' array
    Dim intIndex    As Integer  'Indexing variable
    Dim intUpper    As Integer  'Upper bound of workin' array

    'Convert string to byte array
    bytWork = StrConv(strName & Chr(0), vbFromUnicode)
    'Set for loop boundry
    intUpper = UBound(bytWork)

    'Walk thru array
    For intIndex = 0 To intUpper
        udtLF.lfFaceName(intIndex) = bytWork(intIndex)
    Next

End Property

Public Property Get FontName() As String
    'Retrieve the font name property value

    Dim intIndex    As Integer  'Indexing variable

    FontName = ""   'Initialize return string

    'Convert byte array to string
    For intIndex = 0 To 31
        'Leave when finished
        If Chr(udtLF.lfFaceName(intIndex)) = Chr(0) Then Exit For
        'Set character
        FontName = FontName & Chr(udtLF.lfFaceName(intIndex))
    Next

End Property

Public Property Let FontSize(ByVal lngSize As Long)
    'Assign the font size property value

    Const TPP As Integer = 20    'Twips Per Point

    'Calculate the screen pixel height for a given font point size
    udtLF.lfHeight = lngSize * TPP / Screen.TwipsPerPixelY

End Property

Public Property Get FontSize() As Long
    'Retrieve the font size property value

    FontSize = udtCF.iPointSize / 10

End Property

Public Property Let FontStrikeout(ByVal blnStrikeout As Boolean)
    'Assign the font strikeout property value

    udtLF.lfStrikeOut = blnStrikeout

End Property

Public Property Get FontStrikeout() As Boolean
    'Retrieve font strikeout property value

    FontStrikeout = udtLF.lfStrikeOut

End Property

Public Property Let FontUnderline(ByVal blnUnderline As Boolean)
    'Assign the font underline property value

    udtLF.lfUnderline = blnUnderline

End Property

Public Property Get FontUnderline() As Boolean
    'Retrieve the font underline property value

    FontUnderline = udtLF.lfUnderline

End Property

Public Property Let FontMinSize(ByVal intMinSz As Integer)
    'Assign the font minimum font point size property value. _
     Used with CF_LIMITSIZE flag. _
     - Property Get not defined -

    udtCF.nSizeMin = intMinSz

End Property

Public Property Let FontMaxSize(ByVal intMaxSz As Integer)
    'Assign the font maximum font point size property value. _
     Used with CF_LIMITSIZE flag. _
     - Property Get not defined -

    udtCF.nSizeMax = intMaxSz

End Property

Public Function ShowFont() As Boolean
    'Show the font dialog, do error check & return success status

    Dim intError    As Integer  'Dialog error number

    'Final setup of control structure
    With udtCF
        .hwndOwner = mhwndOwner
        .lpLogFont = lstrcpy(udtLF, udtLF)
        .lCustData = mCustData
        .lpfnHook = mHook
        .lpTemplateName = mTemplateName
        .hInstance = mhInstance
    End With

ReDux:  'Return here for recoverable errors

    'Show the dialog and set the function return value if successful
    ShowFont = ChooseFontF(udtCF)

    If ShowFont Then Exit Function      'Leave if everything is OK
    intError = CommDlgExtendedError()   'Get the error number if not

    'Check for exit of dialog without selection or _
     others that are programming errors
    If ChkCancel(intError) Then GoTo ReDux

End Function


'********************************************************
'*                                                      *
'*  Section:    Printer Dialog Properties & Methods     *
'*  Dialogs:    Printer                                 *
'*  Comments:   Procedures in this section are common   *
'*              only to dialogs listed above and are    *
'*              all public.                             *
'*                                                      *
'********************************************************


Public Property Get Ptr_hDC() As Long
    'Retrieve the device hDc property value. _
     Used with the PD_RETURNDC or PC_RETURNIC flag. _
     - Property Let not defined -

    Ptr_hDC = udtPD.hDC

End Property

Public Property Let PrinterFlags(ByVal dlgFlags As dlgPtrFlags)
    'Assign the flags for dialog initialization _
     - Property Get not defined -

    udtPD.flags = dlgFlags

End Property

Public Property Get FromPage() As Integer
    'Retrieve the from page property value. _
     Used with the PD_PAGENUMS flag.

    FromPage = udtPD.nFromPage

End Property

Public Property Let FromPage(ByVal intFromPage As Integer)
    'Assign the from page property value. Must be less than ToPage. _
     Used with the PD_PAGENUMS flag.

    udtPD.nFromPage = intFromPage

End Property

Public Property Get ToPage() As Integer
    'Retrieve the to page property value. _
     Used with the PD_PAGENUMS flag.

    ToPage = udtPD.nToPage

End Property

Public Property Let ToPage(ByVal intToPage As Integer)
    'Assign the to page property value. Must be more than FromPage. _
     Used with the PD_PAGENUMS flag.

    udtPD.nToPage = intToPage

End Property

Public Property Let MinPage(ByVal intMinPage As Integer)
    'Assign the from page property value. Must be less than MaxPage. _
     Used with the PD_PAGENUMS flag. _
     - Property Get not defined -

    udtPD.nMinPage = intMinPage

End Property

Public Property Let MaxPage(ByVal intMaxPage As Integer)
    'Assign the to page property value. Must be less than MinPage. _
     Used with the PD_PAGENUMS flag. _
     - Property Get not defined -

    udtPD.nMaxPage = intMaxPage

End Property

Public Property Let PrintHook(ByVal lngPrtHook As Long)
    'Assign the handle of the function containing hook procedure. _
     Used with the PD_ENABLEPRINTHOOK flag. _
     - Property Get not defined -

    udtPD.lpfnPrintHook = lngPrtHook

End Property

Public Property Let SetupHook(ByVal lngSetupHook As Long)
    'Assign the handle of the function containing hook procedure. _
     Used with the PD_ENABLESETUPHOOK flag. _
     - Property Get not defined -

    udtPD.lpfnSetupHook = lngSetupHook

End Property

Public Property Let PrintTemplateName(ByVal strPrtTemplateName As String)
    'Assign the name of a dialog template resource. _
     Used with the PD_ENABLEPRINTTEMPLATE flag. _
     - Property Get not defined -

    udtPD.lpPrintTemplateName = strPrtTemplateName & Chr(0)

End Property

Public Property Let SetupTemplateName(ByVal strSetupTemplateName As String)
    'Assign the name of a dialog template resource. _
     Used with the PD_ENABLESETUPTEMPLATE flag. _
     - Property Get not defined -

    udtPD.lpSetupTemplateName = strSetupTemplateName & Chr(0)

End Property

Public Property Let PrintTemplate(ByVal lngPrtTemplate As Long)
    'Assign the handle of the app containing template. _
     Used with the PD_ENABLEPRINTTEMPLATEHANDLE flag. _
     - Property Get not defined -

    udtPD.hPrintTemplate = lngPrtTemplate

End Property

Public Property Let SetupTemplate(ByVal lngSetupTemplate As Long)
    'Assign the handle of the app containing template. _
     Used with the PD_ENABLEPRINTTEMPLATEHANDLE flag. _
     - Property Get not defined -

    udtPD.hSetupTemplate = lngSetupTemplate

End Property

Public Function ShowPrinter() As Boolean
    'Show the printer dialog, do error check, reset _
     printer object & return success status.

    'This is the most complicated and feature rich of the CommonDialog _
     controls to implement via API.  Since actual implementation is so _
     application specific only a very simple example is presented here.

    Dim lngDEVMODE  As Long     'Memory pointer to DEVMODE structure
    Dim lngDEVNAMES As Long     'Memory pointer to DEVNAMES structure
    Dim objPrt      As Printer  'Printer object for comparison
    Dim NewPrinter  As String   'Selected printer name
    Dim intError    As Integer  'Dialog error number

    'Constants for the GlobalAlloc API function
    Const GMEM_MOVEABLE As Long = &H2
    Const GMEM_ZEROINIT As Long = &H40

    'Final setup of control structure
    With udtPD
        .hwndOwner = mhwndOwner
        .hInstance = mhInstance
        .lCustData = mCustData
    End With

    'Tell the DEVMODE structure who the current printer is
    udtDM.dmDeviceName = Printer.DeviceName

    On Error GoTo ErrorHandler  'Extra check for development

    'Allocate memory for DEVMODE structure and tell _
     the PRINTDLG structure where it is.
    udtPD.hDevMode = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(udtDM))

    lngDEVMODE = GlobalLock(udtPD.hDevMode)             'Lock it down
    If lngDEVMODE > 0 Then
        CopyMemory ByVal lngDEVMODE, udtDM, Len(udtDM)  'Force feed it
        intError = GlobalUnlock(lngDEVMODE)             'Let it go
    End If

    On Error GoTo 0     'Work without a safety net

    'Tell the DEVNAMES structure the current printer's vital statistics
    With udtDN
        .wDriverOffset = 8
        .wDeviceOffset = .wDriverOffset + 1 + Len(Printer.DriverName)
        .wOutputOffset = .wDeviceOffset + 1 + Len(Printer.Port)
        .wDefault = 0
        .extra = Printer.DriverName & Chr(0) & Printer.DeviceName & Chr(0) & _
                 Printer.Port & Chr(0)
    End With

    On Error GoTo ErrorHandler  'Extra check for development

    'Allocate memory for DEVNAMES structure and tell _
     the PRINTDLG structure where it is.
    udtPD.hDevNames = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(udtDN))

    lngDEVNAMES = GlobalLock(udtPD.hDevNames)           'Lock it down
    If lngDEVNAMES > 0 Then
       CopyMemory ByVal lngDEVNAMES, udtDN, Len(udtDN)  'Force feed it
       intError = GlobalUnlock(lngDEVNAMES)             'Let it go
    End If

    On Error GoTo 0     'Work without a safety net

ReDux:  'Return here for recoverable errors

    'Show the dialog and set the function return value if successful
    ShowPrinter = PrintDlgF(udtPD)

    'Determine dialog success and act on it
    If ShowPrinter Then     'Dialog did fine
        'Update the DEVMODE structure & free memory
        lngDEVMODE = GlobalLock(udtPD.hDevMode)
        CopyMemory udtDM, ByVal lngDEVMODE, Len(udtDM)
        intError = GlobalUnlock(udtPD.hDevMode)
        GlobalFree udtPD.hDevMode

        'Update the DEVNAMES structure & free memory
        lngDEVNAMES = GlobalLock(udtPD.hDevNames)
        CopyMemory udtDN, ByVal lngDEVNAMES, Len(udtDN)
        intError = GlobalUnlock(lngDEVNAMES)
        GlobalFree udtPD.hDevNames

        'Set selected printer as the current printer if it has changed
        NewPrinter = UCase(Left(udtDM.dmDeviceName, InStr(udtDM.dmDeviceName, _
                     Chr(0)) - 1))

        If Printer.DeviceName <> NewPrinter Then
            For Each objPrt In Printers
                If UCase(objPrt.DeviceName) = NewPrinter Then
                    Set Printer = objPrt
                    Exit For
                End If
            Next
        End If

    Else    'Opps
        intError = CommDlgExtendedError()   'Get the error number if not

        'Check for exit of dialog without selection or _
         others that are programming errors
        If ChkCancel(intError) Then GoTo ReDux
    End If

    Exit Function   'Outta here

ErrorHandler:

    MsgBox Err.Description, vbExclamation, "Memory Error"

End Function
